import { AbstractPowerSyncDatabase, AbstractPowerSyncDatabaseOpenFactory, PowerSyncDatabaseOptions, PowerSyncOpenFactoryOptions } from '@journeyapps/powersync-sdk-common';
import { WebPowerSyncDatabaseOptions, WebPowerSyncFlags } from '../../db/PowerSyncDatabase';
export type WebPowerSyncOpenFlags = {
    enableMultiTabs?: boolean;
    disableSSRWarning?: boolean;
};
export interface WebPowerSyncOpenFactoryOptions extends PowerSyncOpenFactoryOptions {
    flags?: WebPowerSyncOpenFlags;
}
export declare const DEFAULT_POWERSYNC_FLAGS: WebPowerSyncOpenFlags;
/**
 * Intermediate PowerSync Database Open factory for Web which uses a mock
 * SSR DB Adapter if running on server side.
 * Most SQLite DB implementations only run on client side, this will safely return
 * empty query results in SSR which will allow for generating server partial views.
 */
export declare abstract class AbstractWebPowerSyncDatabaseOpenFactory extends AbstractPowerSyncDatabaseOpenFactory {
    protected options: WebPowerSyncOpenFactoryOptions;
    protected isServerSide(): boolean;
    constructor(options: WebPowerSyncOpenFactoryOptions);
    generateOptions(): WebPowerSyncDatabaseOptions;
    protected resolveDBFlags(): WebPowerSyncFlags;
    generateInstance(options: PowerSyncDatabaseOptions): AbstractPowerSyncDatabase;
}
